// DO NOT EDIT! This file was auto-generated by crates/build/re_types_builder/src/codegen/cpp/mod.rs
// Based on "crates/store/re_types/definitions/rerun/blueprint/components/view_fit.fbs".

#pragma once

#include "../../result.hpp"

#include <cstdint>
#include <memory>

namespace arrow {
    /// \private
    template <typename T>
    class NumericBuilder;

    class Array;
    class DataType;
    class UInt8Type;
    using UInt8Builder = NumericBuilder<UInt8Type>;
} // namespace arrow

namespace rerun::blueprint::components {
    /// **Component**: Determines whether an image or texture should be scaled to fit the viewport.
    enum class ViewFit : uint8_t {

        /// No scaling, pixel size will match the image's width/height dimensions in pixels.
        Original = 1,

        /// Scale the image for the largest possible fit in the view's container.
        Fill = 2,

        /// Scale the image for the largest possible fit in the view's container, but keep the original aspect ratio.
        FillKeepAspectRatio = 3,
    };
} // namespace rerun::blueprint::components

namespace rerun {
    template <typename T>
    struct Loggable;

    /// \private
    template <>
    struct Loggable<blueprint::components::ViewFit> {
        static constexpr const char Name[] = "rerun.blueprint.components.ViewFit";

        /// Returns the arrow data type this type corresponds to.
        static const std::shared_ptr<arrow::DataType>& arrow_datatype();

        /// Serializes an array of `rerun::blueprint:: components::ViewFit` into an arrow array.
        static Result<std::shared_ptr<arrow::Array>> to_arrow(
            const blueprint::components::ViewFit* instances, size_t num_instances
        );

        /// Fills an arrow array builder with an array of this type.
        static rerun::Error fill_arrow_array_builder(
            arrow::UInt8Builder* builder, const blueprint::components::ViewFit* elements,
            size_t num_elements
        );
    };
} // namespace rerun
